//*********************************************************************
// Example6SinCos.java
//
// Uses double recursion to calculate sin(x) and cos(x).
//*********************************************************************

public class Example6SinCos
{
   public static void main(String[] args)
   {
      System.out.println("Sine and cosine of 30 degrees: ");
      System.out.println("By our method: " +  Trigo.sin (Math.PI/6) +
                         "\t" + Trigo.cos (Math.PI/6));
      System.out.println("Theoretical:\t" + 1./2 + "\t" + Math.sqrt(3)/2);
   }// method main
}// class Example6SinCos

class Trigo
{
   //=====================================================================
   //  Contains two functions, calculating sin(x) and cos(x).
   //  The calculation is based on the formulas sin(2x)=2sin(x)cos(x)
   //  and cos(2x)=cos^2(x)-sin^2(x). For x~0 we use the approximations
   //  sin(x)~x and cos(x)~1.
   //=====================================================================
   static double sin (double x)
   {
      double sine;
      if (Math.abs(x) < 1E-6)
         sine = x;
      else
         sine = 2 * sin(x/2) * cos(x/2);
         return sine;
   }// method sin

   static double cos (double x)
   {
      double cosine;
      if (Math.abs(x) < 1E-6)
         cosine = 1;
      else
         cosine = Math.pow (cos(x/2), 2) - Math.pow (sin(x/2), 2);
         return cosine;
   }// method cos
}// class Trigo
